﻿var MasquerIcon = false;
var ToujoursPlier = false;
var GrandsPlier = false;
var Ascenseur = false;
var PurePrefs = false;
var Octets = false;

var BackgroundColor = "dfffff";
var CouleurDef = "000000";
var CouleurCom = "008200";
var CouleurPB = "006699";
var CouleurCons = "ff0000";
var CouleurChaineD = "00aa00";
var CouleurChaineS = "00aa00";
var CouleurNombre = "ff9900";
var CouleurFonction = "0000ff";
var CouleurCadre = "2282b2";
var CompilateurPB = "C:\\Program Files\\PureBasic\\";
var PrefsPureBasic = "C:\\Users\\Eric\\AppData\\Roaming\\PureBasic\\PureBasic.prefs";
var LimiterPliage = 20;
var LimiteHeight = 400;
var MaxiOctets = 8000;

var timeoutID = null;
function TimerCode(){
	try{
		if(window.content.document.location.href.search("http://www.purebasic.fr/") > -1 || window.content.document.location.href.search("http://www.developpez.net/") > -1){
			if(window.content.document.getElementById("EventsRX").innerHTML){
				var action = window.content.document.getElementById("EventsRX").innerHTML;
				window.content.document.getElementById("EventsRX").innerHTML="";
				var reg = new RegExp("[|]+", "g");
				var actions = action.split(reg);
				if(actions[0]=="copier"){
					try{
						Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper).copyString(window.content.document.getElementById(actions[1]).textContent);
						var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
						alertsService.showAlertNotification("http://www.rx14.info/images/logo24.png","PureBasic Forum Code", GetVar("code.PressePapier"), false, "", null);
					}catch(e){
						alert("La permission de copier a été refusée.");
					}
				}else if(actions[0]=="ouvrir"){
					var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
					file.append("code.pb");
					file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
					
					var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					aFile.initWithPath(file.path);
					
					var str = window.content.document.getElementById(actions[1]).textContent;
					
					var aStream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
					aStream.init(aFile, 0x02 | 0x08 | 0x20, 0777, null);
					aStream.write(str, str.length);
					aStream.close();
					
					aFile.launch();
				}else if(actions[0]=="compiler"){
					var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
					file.append("code.pb");
					file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
					
					var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					aFile.initWithPath(file.path);
					
					var str = window.content.document.getElementById(actions[1]).textContent;
					
					var aStream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
					aStream.init(aFile, 0x02 | 0x08 | 0x20, 0777, null);
					aStream.write(str, str.length);
					aStream.close();
					
					var args = [CompilateurPB,file.path];
					var PBCompile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					if(getPlatform()=="windows"){
						var N = ChromeToFile("chrome://pbforumcode/content/CompilePBForumCode.exe");
						PBCompile.initWithPath(N.substr(1).replace(/%7B/g, '{').replace(/%7D/g, '}').replace(/[\/]/g, '\\\\'));
					}else{// Linux
						var N = ChromeToFile("chrome://pbforumcode/content/CompilePBForumCode");
						PBCompile.initWithPath(N.replace(/%7B/g, '{').replace(/%7D/g, '}'));
					}
					var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
					process.init(PBCompile);
					process.run(false, args, args.length);
				}
			}
		}
	}catch(e){}
	timeoutID = window.setTimeout("TimerCode()",1000);
}
if(timeoutID==null){
	prefs_init();
	//Update();
	TimerCode();
}
function GetVar(v){return document.getElementById(v).label;}
function getPlatform(){
	var platform = navigator.platform.toLowerCase();
	if(platform.indexOf('linux') != -1) return 'linux';
	if(platform.indexOf('mac') != -1) return 'mac';
	return 'windows';
}
//################################################################################################################################################################
function prefs_init(){
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService ).getBranch("extensions.pbforumcode");
	if(preferencesService.prefHasUserValue("CouleurDef")) CouleurDef = preferencesService.getCharPref("CouleurDef");
	if(preferencesService.prefHasUserValue("CouleurCom")) CouleurCom = preferencesService.getCharPref("CouleurCom");
	if(preferencesService.prefHasUserValue("CouleurPB")) CouleurPB = preferencesService.getCharPref("CouleurPB");
	if(preferencesService.prefHasUserValue("CouleurCons")) CouleurCons = preferencesService.getCharPref("CouleurCons");
	if(preferencesService.prefHasUserValue("CouleurChaineD")) CouleurChaineD = preferencesService.getCharPref("CouleurChaineD");
	if(preferencesService.prefHasUserValue("CouleurChaineS")) CouleurChaineS = preferencesService.getCharPref("CouleurChaineS");
	if(preferencesService.prefHasUserValue("CouleurNombre")) CouleurNombre = preferencesService.getCharPref("CouleurNombre");
	if(preferencesService.prefHasUserValue("CouleurFonction")) CouleurFonction = preferencesService.getCharPref("CouleurFonction");
	if(preferencesService.prefHasUserValue("CouleurCadre")) CouleurCadre = preferencesService.getCharPref("CouleurCadre");
	if(preferencesService.prefHasUserValue("CompilateurPB")) CompilateurPB = preferencesService.getCharPref("CompilateurPB");
	if(preferencesService.prefHasUserValue("PrefsPureBasic")) PrefsPureBasic = preferencesService.getCharPref("PrefsPureBasic");
	if(preferencesService.prefHasUserValue("LimiteHeight")) LimiteHeight = preferencesService.getIntPref("LimiteHeight");
	if(preferencesService.prefHasUserValue("LimiterPliage")) LimiterPliage = preferencesService.getIntPref("LimiterPliage");
	if(preferencesService.prefHasUserValue("MaxiOctets")) MaxiOctets = preferencesService.getIntPref("MaxiOctets");
	
	if(preferencesService.prefHasUserValue("MasquerIcon")) MasquerIcon = preferencesService.getBoolPref("MasquerIcon");
	if(preferencesService.prefHasUserValue("ToujoursPlier")) ToujoursPlier = preferencesService.getBoolPref("ToujoursPlier");
	if(preferencesService.prefHasUserValue("GrandsPlier")) GrandsPlier = preferencesService.getBoolPref("GrandsPlier");
	if(preferencesService.prefHasUserValue("Ascenseur")) Ascenseur = preferencesService.getBoolPref("Ascenseur");
	if(preferencesService.prefHasUserValue("PurePrefs")) PurePrefs = preferencesService.getBoolPref("PurePrefs");
	if(preferencesService.prefHasUserValue("Octets")) Octets = preferencesService.getBoolPref("Octets");
	
	if(PurePrefs) GetPreferences();
}
function prefs_Options(){
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService ).getBranch("extensions.pbforumcode");
	CouleurDef = document.getElementById("CouleurDef").value;
	CouleurCom = document.getElementById("CouleurCom").value;
	CouleurPB = document.getElementById("CouleurPB").value;
	CouleurCons = document.getElementById("CouleurCons").value;
	CouleurChaineD = document.getElementById("CouleurChaineD").value;
	CouleurChaineS = document.getElementById("CouleurChaineS").value;
	CouleurNombre = document.getElementById("CouleurNombre").value;
	CouleurFonction = document.getElementById("CouleurFonction").value;
	CouleurCadre = document.getElementById("CouleurCadre").value;
	CompilateurPB = document.getElementById("CompilateurPB").value;
	PrefsPureBasic = document.getElementById("PrefsPureBasic").value;
	LimiteHeight = parseInt(document.getElementById("LimiteHeight").value);
	LimiterPliage = parseInt(document.getElementById("LimiterPliage").value);
	MaxiOctets = parseInt(document.getElementById("MaxiOctets").value);
	
	MasquerIcon = document.getElementById("MasquerIcon").checked;
	ToujoursPlier = document.getElementById("ToujoursPlier").checked;
	GrandsPlier = document.getElementById("GrandsPlier").checked;
	Ascenseur = document.getElementById("Ascenseur").checked;
	PurePrefs = document.getElementById("PurePrefs").checked;
	Octets = document.getElementById("Octets").checked;
	
	preferencesService.setCharPref("CouleurDef",CouleurDef);
	preferencesService.setCharPref("CouleurCom",CouleurCom);
	preferencesService.setCharPref("CouleurPB",CouleurPB);
	preferencesService.setCharPref("CouleurCons",CouleurCons);
	preferencesService.setCharPref("CouleurChaineD",CouleurChaineD);
	preferencesService.setCharPref("CouleurChaineS",CouleurChaineS);
	preferencesService.setCharPref("CouleurNombre",CouleurNombre);
	preferencesService.setCharPref("CouleurFonction",CouleurFonction);
	preferencesService.setCharPref("CouleurCadre",CouleurCadre);
	preferencesService.setCharPref("CompilateurPB",CompilateurPB);
	preferencesService.setCharPref("PrefsPureBasic",PrefsPureBasic);
	preferencesService.setIntPref("LimiteHeight",LimiteHeight);
	preferencesService.setIntPref("LimiterPliage",LimiterPliage);
	preferencesService.setIntPref("MaxiOctets",MaxiOctets);
	
	preferencesService.setBoolPref("MasquerIcon",MasquerIcon);
	preferencesService.setBoolPref("ToujoursPlier",ToujoursPlier);
	preferencesService.setBoolPref("GrandsPlier",GrandsPlier);
	preferencesService.setBoolPref("Ascenseur",Ascenseur);
	preferencesService.setBoolPref("PurePrefs",PurePrefs);
	preferencesService.setBoolPref("Octets",Octets);
}
function options_Affiche(){
	document.getElementById("CouleurDef").value = CouleurDef;
	document.getElementById("CouleurCom").value = CouleurCom;
	document.getElementById("CouleurPB").value = CouleurPB;
	document.getElementById("CouleurCons").value = CouleurCons;
	document.getElementById("CouleurChaineD").value = CouleurChaineD;
	document.getElementById("CouleurChaineS").value = CouleurChaineS;
	document.getElementById("CouleurNombre").value = CouleurNombre;
	document.getElementById("CouleurFonction").value = CouleurFonction;
	document.getElementById("CouleurCadre").value = CouleurCadre;
	document.getElementById("CompilateurPB").value = CompilateurPB;
	document.getElementById("PrefsPureBasic").value = PrefsPureBasic;
	document.getElementById("LimiteHeight").value = LimiteHeight;
	document.getElementById("LimiterPliage").value = LimiterPliage;
	document.getElementById("MaxiOctets").value = MaxiOctets;
	
	document.getElementById("MasquerIcon").checked = MasquerIcon;
	document.getElementById("ToujoursPlier").checked = ToujoursPlier;
	document.getElementById("GrandsPlier").checked = GrandsPlier;
	if(!GrandsPlier) document.getElementById('LimiterPliage').disabled = true;
	document.getElementById("Ascenseur").checked = Ascenseur;
	if(!Ascenseur) document.getElementById('LimiteHeight').disabled = true;
	document.getElementById("PurePrefs").checked = PurePrefs;
	if(!PurePrefs) document.getElementById('PrefsPureBasic').disabled = true;
	document.getElementById("Octets").checked = Octets;
	if(!Octets) document.getElementById('MaxiOctets').disabled = true;
}
//################################################################################################################################################################
var HTML = "";
var LeMot = "";
var IsPureBasic = 0;
var IsNotPureBasic = 0;
var IDCode = 0;
var Posting = 0;
var IsMotPB = " EndIf EndProcedure EndWith EndStructure EndEnumeration EndDataSection EndMacro EndImport";
var IsNotMotPB = "void int struct";
function AjouteLeMot(){
	if(LeMot.length>0){
		var IsNum = true;
		for(var i=0; i<LeMot.length; i++){
			if(LeMot.charAt(i)<'0' || LeMot.charAt(i)>'9'){
				IsNum = false;
				break;
			}
		}
		if(IsNum){
			HTML += '<span class="PBDec">'+LeMot+'</span>';
		}else{
			var MonMot = LeMot.replace(/(\s?)\b(And|Break|CallDebugger|Case|Class|CompilerCase|CompilerDefault|CompilerElse|CompilerEndIf|CompilerEndSelect|CompilerIf|CompilerSelect|Continue|Data|DataSection|Debug|DebugLevel|Declare|DeclareCDLL|DeclareDLL|DeclareModule|Default|Define|DefType|Delay|Dim|DisableDebugger|DisableExplicit|Else|ElseIf|EnableDebugger|EnableExplicit|End|EndClass|EndDataSection|EndDeclareModule|EndEnumeration|EndIf|EndImport|EndInterface|EndMacro|EndModule|EndProcedure|EndSelect|EndStructure|EndStructureUnion|EndWith|Enumeration|Extends|FakeReturn|For|ForEach|ForEver|Global|Gosub|Goto|If|Import|ImportC|IncludeBinary|IncludeFile|IncludePath|Interface|Macro|Module|NewList|Next|Not|Or|Procedure|ProcedureC|ProcedureCDLL|ProcedureDLL|ProcedureReturn|Protected|Read|Repeat|Restore|Return|Select|Shared|Static|Step|Structure|StructureUnion|To|Until|UnuseModule|UseModule|Wend|While|XIncludeFile|new|This|WaitWindowEvent|WindowEvent|With|NewMap|Map)\b(\s?)/gi, '$1<span class="PBKey">$2</span>$3');
			if(LeMot.length==MonMot.length){
				if(IsNotMotPB.search(LeMot)) IsNotPureBasic+=1000;
				else IsNotPureBasic++;
			}else{
				if(IsMotPB.search(LeMot)) IsPureBasic+=10000;
				else IsPureBasic++;
			}
			HTML += MonMot;
		}
		LeMot = "";
	}
}
function ColoreCode(Code,IsHTML) {
	if(IsHTML){
		var s = div2pre(Code.innerHTML);
		var txt = div2pre(Code.innerHTML);
	}else{
		var s = Code.textContent;
		var txt = Code.textContent;
	}
	var txtOk = "";
	var IsDebutLigne = 1;
	var NombreLigne = 0;
	for(var i=0; i<txt.length; i++){
		if(txt.charCodeAt(i)==160 || txt.charAt(i)==' ' || txt.charAt(i)=='\t'){
			if(IsDebutLigne){
				if(txt.charAt(i)!=' ') txtOk += '\t';
			}else txtOk += ' ';
			continue;
		}else if(txt.charAt(i)=='\n'){
			txtOk += '\n';
			NombreLigne++;
			IsDebutLigne = 1;
		}else if(txt.charAt(i)=='<'){
			txtOk += '&lt;';
			if(IsDebutLigne) IsDebutLigne = 0;
		}else if(txt.charAt(i)=='>'){
			txtOk += '&gt;';
			if(IsDebutLigne) IsDebutLigne = 0;
		}else{
			if(txt.charAt(i)=='\n') NombreLigne++;
			txtOk += s.charAt(i);
			if(IsDebutLigne) IsDebutLigne = 0;
		}
	}
	var NbLigne = 0;
	HTML = "";
	if(IDCode++==0) HTML += '<div id="EventsRX" style="display:none;"></div>';
	HTML += '<div id="copieducode'+IDCode+'" style="display:none;">'+txtOk+'</div>';
	HTML += '<div class="tl"></div>';
	HTML += '<a href="#" title="'+GetVar("code.PlierDeplier2")+'" class="pliageRX" onclick="document.getElementById(\'codeOriginal'+IDCode+'\').style.display=\'none\';var lecode=document.getElementById(\'lecode'+IDCode+'\');lecode.style.display=lecode.style.display==\'none\'?\'block\':\'none\';return false;" style="color:#eeeeee;">'+GetVar("code.PlierDeplier")+'</a>';
	HTML += '<a href="#" title="'+GetVar("code.Original2")+'" class="pliageRX" onclick="if(document.getElementById(\'codeOriginal'+IDCode+'\').style.display==\'block\'){document.getElementById(\'lecode'+IDCode+'\').style.display=\'block\';document.getElementById(\'codeOriginal'+IDCode+'\').style.display=\'none\';}else{document.getElementById(\'lecode'+IDCode+'\').style.display=\'none\';document.getElementById(\'codeOriginal'+IDCode+'\').style.display=\'block\';}return false;" style="color:#eeeeee;">'+GetVar("code.Original")+'</a>';
	HTML += '<a href="#" title="'+GetVar("code.Copier2")+'" class="pliageRX" onclick=\'document.getElementById("EventsRX").innerHTML="copier|copieducode'+IDCode+'";return false;\' style="color:#eeeeee;">'+GetVar("code.Copier")+'</a>';
	HTML += '<a href="#" title="'+GetVar("code.Ouvrir2")+'" class="pliageRX" onclick=\'document.getElementById("EventsRX").innerHTML="ouvrir|copieducode'+IDCode+'";return false;\' style="color:#eeeeee;">'+GetVar("code.Ouvrir")+'</a>';
	if(getPlatform()=="windows" || getPlatform()=="linux") HTML += '<a href="#" title="'+GetVar("code.Compiler2")+'" class="pliageRX" onclick=\'document.getElementById("EventsRX").innerHTML="compiler|copieducode'+IDCode+'";return false;\' style="color:#eeeeee;">'+GetVar("code.Compiler")+'</a>';
	HTML += '<div id="codeOriginal'+IDCode+'" class="codeOriginal" style="display:none;clear:left;">'+Code.innerHTML+'</div>';
	HTML += '<div id="lecode'+IDCode+'" style="'+(Ascenseur?'max-height:'+LimiteHeight+'px;overflow-y:auto;':'')+'clear:left;'+(ToujoursPlier||(GrandsPlier&&NombreLigne>LimiterPliage)?'display:none;':'')+'"><table class="affCode" cellpadding="0" cellspacing="0"><tr><td class="nl0">'+(s.length<MaxiOctets?'<input type="text" value="1" disabled="disabled"/>':'')+'</td><td class="p0">';
	LeMot = "";
	IsPureBasic = 0;
	IsNotPureBasic = 0;
	IsDebutLigne = 1;
	
	if(!Octets || s.length<MaxiOctets){
		for(var i=0; i<s.length; i++){
			if(IsDebutLigne && (s.charCodeAt(i)==160 || s.charAt(i)==' ' || s.charAt(i)=='\t')){
				if(s.charAt(i)!=' ') HTML += '<span class="PBTab">	</span>';
				continue;
			}else if(IsDebutLigne) IsDebutLigne = 0;
			if((s.charAt(i)>='a' && s.charAt(i)<='z') || (s.charAt(i)>='A' && s.charAt(i)<='Z') || (s.charAt(i)>='0' && s.charAt(i)<='9') || s.charAt(i)=='_'){
				LeMot += s.charAt(i);
			}else{
				switch(s.charAt(i)){
					case '#':// Constantes
						AjouteLeMot();
						HTML += '<span class="PBCons">#';
						while((s.charAt(++i)>='a' && s.charAt(i)<='z') || (s.charAt(i)>='A' && s.charAt(i)<='Z') || (s.charAt(i)>='0' && s.charAt(i)<='9') || s.charAt(i)=='_') HTML += s.charAt(i);
						HTML += '</span>';
						i--;
						break;
					case ';':// Commentaires
						AjouteLeMot();
						HTML += '<span class="PBCom">;';
						while(s.charAt(++i)!='\n' && i<s.length){
							if(s.charAt(i)=='<') HTML += "&lt;";
							else if(s.charAt(i)=='>') HTML +="&gt;";
							else HTML += s.charAt(i);
						}
						HTML += '</span>';
						i--;
						break;
					case '(':// Fonctions
						if(LeMot.length>0) HTML += '<span class="PBFunc">'+LeMot+'</span>(';
						else HTML += '(';
						LeMot = "";
						break;
					case '"':// Quotes double
						AjouteLeMot();
						HTML += '<span class="PBQD">"';
						while(s.charAt(++i)!='"' && s.charAt(i)!="\n" && i<s.length){
							if(s.charAt(i)=='<') HTML += "&lt;";
							else if(s.charAt(i)=='>') HTML +="&gt;";
							else HTML += s.charAt(i);
						}
						if(s.charAt(i)=='"') HTML += '"</span>';
						else if(Posting) HTML += '</span></td></tr>\n<tr><td class="nl'+(++NbLigne%2)+'"><input type="text" value="'+(NbLigne+1)+'" disabled="disabled"/></td><td class="p'+(NbLigne%2)+'">';
						else HTML += '</span>';
						break;
					case "'":// Quotes simple
						AjouteLeMot();
						HTML += '<span class="PBQS">\'';
						while(s.charAt(++i)!="'" && s.charAt(i)!="\n" && i<s.length){
							if(s.charAt(i)=='<') HTML += "&lt;";
							else if(s.charAt(i)=='>') HTML +="&gt;";
							else HTML += s.charAt(i);
						}
						if(s.charAt(i)=="'") HTML += "'</span>";
						else if(Posting) HTML += '</span></td></tr>\n<tr><td class="nl'+(++NbLigne%2)+'"><input type="text" value="'+(NbLigne+1)+'" disabled="disabled"/></td><td class="p'+(NbLigne%2)+'">';
						else HTML += "</span>";
						break;
					case '$':// Chiffres Hexa
						if(LeMot){// à la suite d'un mot, c'est une variable de type String
							AjouteLeMot();
							HTML += "$";
						}else{
							HTML += '<span class="PBDec">'+s.charAt(i);
							while((s.charAt(++i)>='a' && s.charAt(i)<='f') || (s.charAt(i)>='A' && s.charAt(i)<='F') || (s.charAt(i)>='0' && s.charAt(i)<='9')) HTML += s.charAt(i);
							HTML += '</span>';
							i--;
						}
						break;
					case '\n':
						IsDebutLigne = 1;
						AjouteLeMot();
						HTML += '&nbsp;</td></tr>\n<tr><td class="nl'+(++NbLigne%2)+'"><input type="text" value="'+(NbLigne+1)+'" disabled="disabled"/></td><td class="p'+(NbLigne%2)+'">';
						if(NbLigne>2000) return 0;
						//if(!Posting && s.charAt(i+1)=='\n') i++;
						break;
					case '\t':
						AjouteLeMot();
						if(IsDebutLigne) HTML += '<span class="PBTab">	</span>';
						else HTML += "&nbsp;";
						break;
					case '<':
						AjouteLeMot();
						HTML += "&lt;";
						break;
					case '>':
						AjouteLeMot();
						HTML += "&gt;";
						break;
					default:
						AjouteLeMot();
						HTML += s.charAt(i);
						break;
				}
			}
		}
		AjouteLeMot();
	}else{
		HTML += Code.innerHTML;
		IsNotPureBasic = 0;
		IsPureBasic = 1;
	}
    if((IsNotPureBasic==0 && IsPureBasic) || (IsNotPureBasic && ((IsPureBasic*100)/IsNotPureBasic > 10))){
		Code.innerHTML = HTML+'</td></tr></table>';
		return 1;
	}else{
		if(IDCode==1) IDCode = 0;
		return 0;
	}
}
window.addEventListener("DOMContentLoaded", function() { myExtension.init(); }, false);
var myExtension = {
	init: function() {
		window.removeEventListener('DOMContentLoaded', myExtension.init, false);
		var appcontent = document.getElementById("appcontent");   // browser
		if(appcontent){
			appcontent.addEventListener("DOMContentLoaded", myExtension.onPageLoad, true);
			gBrowser.tabContainer.addEventListener("TabSelect", myExtension.onTabSelect, false);
		}
	},
	onTabSelect: function(aEvent){
		var doc = gBrowser.selectedBrowser.contentDocument;
		myExtension.analyzePage(doc);
	},
	onPageLoad: function(aEvent){
		var doc = aEvent.originalTarget;
		myExtension.analyzePage(doc);
	},
	analyzePage: function(doc){
		if(doc.location.href.search("www.purebasic.fr") > -1){
			IDCode = 0;
			var prosilver = false;
			if(doc.styleSheets[0] && doc.styleSheets[0].href){
				if(doc.styleSheets[0].href.search(/prosilver/)>=0) prosilver = true;
			}
			var sty = prosilver ? doc.styleSheets[1] : doc.styleSheets[0];
			if(sty){
				sty.insertRule(".affCode{width:100%;font:11px Verdana, Geneva, Arial, Helvetica, sans-serif;}",sty.cssRules.length);
				sty.insertRule(".affCode td.nl0,.affCode td.nl1{width:30px;background-color:#"+CouleurCadre+";}",sty.cssRules.length);
				sty.insertRule(".affCode td.nl0 input[disabled],.affCode td.nl1 input[disabled]{border:none;width:"+(prosilver?30:26)+"px;height:9px;text-align:right;padding:0 4px 0 0;font:11px Verdana, Geneva, Arial, Helvetica, sans-serif;color:#fff;cursor:default;background-color:#"+CouleurCadre+";}",sty.cssRules.length);
				sty.insertRule(".affCode td.p0{background-color:#ffffdf;padding:0 0 0 2px;margin:0;height:7px;line-height:13px;}",sty.cssRules.length);
				sty.insertRule(".affCode td.p1{background-color:#ffffdf;padding:0 0 0 2px;margin:0;height:7px;line-height:13px;}",sty.cssRules.length);
				sty.insertRule(".codeOriginal{border-left:34px solid #"+CouleurCadre+";padding-left:2px;}",sty.cssRules.length);
				sty.insertRule(".tl{width:34px;height:22px;float:left;background-color:#"+CouleurCadre+";margin-right:10px;}",sty.cssRules.length);
				sty.insertRule(".PBCom{color:#"+CouleurCom+";font-style:italic;}",sty.cssRules.length);
				sty.insertRule(".PBKey{color:#"+CouleurPB+";font-weight:bold;}",sty.cssRules.length);
				sty.insertRule(".PBCons{color:#"+CouleurCons+";}",sty.cssRules.length);
				sty.insertRule(".PBQD{color:#"+CouleurChaineD+";}",sty.cssRules.length);
				sty.insertRule(".PBQS{color:#"+CouleurChaineS+";}",sty.cssRules.length);
				sty.insertRule(".PBDec{color:#"+CouleurNombre+";}",sty.cssRules.length);
				sty.insertRule(".PBFunc{color:#"+CouleurFonction+";}",sty.cssRules.length);
				sty.insertRule(".pliageRX{display:inline-block;padding:0 20px 3px 20px;margin-right:6px;margin-bottom:4px;text-decoration:none;text-align:center;font-weight:bold;background-color:#"+CouleurCadre+";border-radius:0 0 3px 3px;text-shadow:1px 1px 1px #000;box-shadow:rgba(0,0,0,1) 0 1px 2px;-moz-transition:background 400ms linear;}",sty.cssRules.length);
				sty.insertRule(".pliageRX:hover{text-decoration:none;color:#ffffff;background-color:#44ccff;-moz-transition:background 400ms linear;}",sty.cssRules.length);
				sty.insertRule(".PBTab{white-space:pre;display:inline-block;width:24px;height:13px;background:url('http://www.rx14.info/images/Tab.png') center left no-repeat;margin:0;padding:0;}",sty.cssRules.length);
			}
			if(prosilver){
				var dl = doc.getElementsByTagName("dl");
				var Tdl = new Array();
				for(var t=0;t<dl.length;t++) Tdl[t] = dl[t];
				for(var t=0;t<Tdl.length;t++){
					if(Tdl[t].className=='codebox'){
						var CodeAFaire = Tdl[t].firstChild.nextSibling.firstChild;
						if(ColoreCode(CodeAFaire,true)){
							Tdl[t].className='CodeOK';
							Tdl[t].style.cssText='background-color:#ffffdf;color:#'+CouleurDef+';font: 11px Verdana, Geneva, Arial, Helvetica, sans-serif;padding:0;margin:4px 10px 0 10px;min-height:20px;box-shadow:rgba(0,0,0,1) 0 0 5px;';
							Tdl[t].innerHTML = CodeAFaire.innerHTML;
						}
					}
				}
			}else{
				var tbls = doc.getElementsByTagName("div");
				var TitreCode = null;
				for(var t=0;t<tbls.length;t++){
					var thisTbl = tbls[t];
					if(thisTbl.className=='codecontent'){
						Posting = doc.location.href.search("/posting.php") > -1 ? 1 : 0;
						if(ColoreCode(thisTbl,true)){
							thisTbl.className='CodeOK';
							thisTbl.style.cssText='background-color:#f7f7f7;color:#'+CouleurDef+';font: 11px Verdana, Geneva, Arial, Helvetica, sans-serif;padding:0;margin:4px 0 0 0;min-height:20px;box-shadow:rgba(0,0,0,1) 0 0 5px;';
							if(TitreCode) TitreCode.style.cssText='display:none;';
						}
					}else if(thisTbl.className=='codetitle') TitreCode = thisTbl;
				}
			}
		}else if(doc.location.href.search("www.developpez.net/forums/") > -1 && doc.location.href.search("/purebasic/") > -1){
			IDCode = 0;
			doc.styleSheets[0].insertRule(".affCode{width:100%;font:11px Verdana, Geneva, Arial, Helvetica, sans-serif;}",0);
			doc.styleSheets[0].insertRule(".affCode td.nl0,.affCode td.nl1{width:30px;background-color:#"+CouleurCadre+";}",0);
			doc.styleSheets[0].insertRule(".affCode td.nl0 input[disabled],.affCode td.nl1 input[disabled]{border:none;width:30px;height:9px;text-align:right;padding:0 4px 0 0;font:11px Verdana, Geneva, Arial, Helvetica, sans-serif;color:#fff;cursor:default;background-color:#"+CouleurCadre+";}",0);
			doc.styleSheets[0].insertRule(".affCode td.p0{background-color:#f7fcff;padding:0 0 0 2px;margin:0;height:7px;line-height:13px;}",0);
			doc.styleSheets[0].insertRule(".affCode td.p1{background-color:#f7f7f7;padding:0 0 0 2px;margin:0;height:7px;line-height:13px;}",0);
			doc.styleSheets[0].insertRule(".codeOriginal{border-left:34px solid #"+CouleurCadre+";padding-left:2px;}",0);
			doc.styleSheets[0].insertRule(".tl{width:34px;height:22px;float:left;background-color:#"+CouleurCadre+";margin-right:10px;}",0);
			doc.styleSheets[0].insertRule(".PBCom{color:#"+CouleurCom+";font-style:italic;}",0);
			doc.styleSheets[0].insertRule(".PBKey{color:#"+CouleurPB+";font-weight:bold;}",0);
			doc.styleSheets[0].insertRule(".PBCons{color:#"+CouleurCons+";}",0);
			doc.styleSheets[0].insertRule(".PBQD{color:#"+CouleurChaineD+";}",0);
			doc.styleSheets[0].insertRule(".PBQS{color:#"+CouleurChaineS+";}",0);
			doc.styleSheets[0].insertRule(".PBDec{color:#"+CouleurNombre+";}",0);
			doc.styleSheets[0].insertRule(".PBFunc{color:#"+CouleurFonction+";}",0);
			doc.styleSheets[0].insertRule(".pliageRX{display:inline-block;padding:0 20px 4px 20px;margin-right:4px;margin-bottom:4px;text-decoration:none;text-align:center;font-weight:bold;background-color:#"+CouleurCadre+";border-radius:0 0 3px 3px;text-shadow:1px 1px 1px #000;box-shadow:rgba(0,0,0,1) 0 1px 2px;-moz-transition:background 400ms linear;}",0);
			doc.styleSheets[0].insertRule(".pliageRX:hover{text-decoration:none;color:#ffffff;background-color:#44ccff;-moz-transition:background 400ms linear;}",0);
			doc.styleSheets[0].insertRule(".PBTab{display:block;width:24px;height:13px;background:url('http://www.rx14.info/images/Tab.png') center left no-repeat;cursor:text;float:left;}",0);
			
			var tbls = doc.getElementsByTagName("pre");
			var TPre = new Array();
			for(var t=0;t<tbls.length;t++) TPre[t] = tbls[t];
			for(var t=0;t<TPre.length;t++){
				var thisTbl = TPre[t];
				if(thisTbl.className=='alt2'){
					var monParent = thisTbl.parentNode;
					monParent.innerHTML = s2nbsp(nl2br(thisTbl.innerHTML));
					Posting = doc.location.href.search("/posting.php") > -1 ? 1 : 0;
					if(ColoreCode(monParent,false)){
						monParent.className='CodeOK';
						monParent.style.cssText='background-color:#f7f7f7;color:#'+CouleurDef+';font: 11px Verdana, Geneva, Arial, Helvetica, sans-serif;padding:0;margin:10px 20px 10px 20px;min-height:20px;box-shadow:rgba(0,0,0,1) 0 0 5px;';
					}
				}
			}
			
		}
 	}
}
var RX14PopUp = {
	open: function() {
		var windowName = GetVar("about.Title");
		var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = windowsMediator.getMostRecentWindow(windowName);
		if (win) {
			win.focus();
		} else {
			openDialog("chrome://pbforumcode/content/about.xul", windowName, "chrome,dialog=no,centerscreen");
		}
	},
	openOptions: function() {
		var windowName = GetVar("options.Title");
		var windowsMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = windowsMediator.getMostRecentWindow(windowName);
		if (win) {
			win.focus();
		} else {
			openDialog("chrome://pbforumcode/content/options.xul", windowName, "chrome,dialog=no,centerscreen,resizable=no,width=740,height=440");
		}
	},
	handleStatusClick: function(event) {
		if (event.target.id == "rx-statusbar-panel") {
			if (event.button == 2)  event.target.firstChild.showPopup();
		}
	},
	addBlank: function() {
		stylishCommon.add("");
	},
	clearMenu: function(event) {
		var popup = event.target;
		while (popup.hasChildNodes()) {
			popup.removeChild(popup.firstChild);
		}
	}
}
const REF_URI = Components.Constructor("@mozilla.org/network/standard-url;1", "nsIURI");
var REF = new REF_URI;
REF.spec = 'http://www.rx14.info/';
function LoadURL(url, openTab){
	if(openTab){
		var newTab = getBrowser().addTab(url, REF, null, null);
		getBrowser().selectedTab = newTab;
	}else{
		getBrowser().webNavigation.loadURI(url, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, REF, null, null);
	}
}
function nl2br(str, is_xhtml){
	var breakTag = '<br/>';
	if (typeof is_xhtml != 'undefined' && !is_xhtml) breakTag = '<br>';
	return (str + '').replace(/([^>]?)\n/g, '$1'+ breakTag +'\n\n\n');
}
function div2pre(str){
	str = str.replace(/<br\s*\/?>/mg,"\n");
	str = str.replace(/&nbsp;/mg,"\t");
	str = str.replace(/&lt;/mg,"<");
	str = str.replace(/&gt;/mg,">");
	str = str.replace(/&amp;/mg,"&");
	str = str.replace(/<span class="posthilit">(.*)<\/span>/mg,'$1');
	return str;
}
function s2nbsp(str){return (str+'').replace(/([^>]?)\s\s/g, '$1 &nbsp;');}
function ChromeToFile(Fichier){// Convertion de l'adresse chrome en adresse "file://"
	var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var ch_ec = ios.newURI(Fichier, null, null);
	var chs = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistry)
	var ch = chs.convertChromeURL(ch_ec);
	return ch.path;
}
function int2hex(dec){var Hexa="0123456789ABCDEF";return Hexa.charAt(dec>>4&0xf)+Hexa.charAt(dec>>0&0xf)+Hexa.charAt(dec>>12&0xf)+Hexa.charAt(dec>>8&0xf)+Hexa.charAt(dec>>20&0xf)+Hexa.charAt(dec>>16&0xf);}
function GetPreferences() {
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(PrefsPureBasic);
	if(file.exists()==false)return false;
	var is = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance( Components.interfaces.nsIFileInputStream );
	is.init( file,0x01, 00004, null);
	var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance( Components.interfaces.nsIScriptableInputStream );
	sis.init( is );
	var output = sis.read(sis.available() );
	
	BackgroundColor = int2hex(parseInt(("-"+output.match(/BackgroundColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurPB = int2hex(parseInt(("-"+output.match(/BasicKeywordColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurCom = int2hex(parseInt(("-"+output.match(/CommentColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurCons = int2hex(parseInt(("-"+output.match(/ConstantColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurDef = int2hex(parseInt(("-"+output.match(/NormalTextColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurNombre = int2hex(parseInt(("-"+output.match(/NumberColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurFonction = int2hex(parseInt(("-"+output.match(/PureKeywordColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurChaineD = int2hex(parseInt(("-"+output.match(/StringColor([= 0-9]+)/gi)).split(/[=]+/g)[1]));
	CouleurChaineS = CouleurChaineD;
	
	return true;
}
function SetClipboard(Texte){
	var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
	if (!clip) return;
	var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return;
	trans.addDataFlavor('text/unicode');
	var clipid = Components.interfaces.nsIClipboard;
	if (!clip) return false;
	var str = new Object();
	var len = new Object();
	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	str.data = LeCode;
	trans.setTransferData("text/unicode", str, LeCode.length*2);
	clip.setData(trans, null, clipid.kGlobalClipboard);
}
function GetClipboard(){
	var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
	if (!clip) return;
	var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
	if (!trans) return;
	trans.addDataFlavor('text/unicode');
	var clipid = Components.interfaces.nsIClipboard;
	if (!clip) return false;
	var str = new Object();
	var len = new Object();
	clip.getData(trans, clipid.kGlobalClipboard);
	trans.getTransferData("text/unicode", str, len);
	if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0, len.value / 2);
	return pastetext;
}
function Update(){
	var args = [];
	var PBFCUpdate = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	if(getPlatform()=="windows"){
		var N = ChromeToFile("chrome://pbforumcode/content/Update.exe");
		PBFCUpdate.initWithPath(N.substr(1).replace(/%7B/g, '{').replace(/%7D/g, '}').replace(/[\/]/g, '\\\\'));
	}else{// Linux
		var N = ChromeToFile("chrome://pbforumcode/content/Update");
		PBFCUpdate.initWithPath(N.replace(/%7B/g, '{').replace(/%7D/g, '}'));
	}
	var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
	process.init(PBFCUpdate);
	process.run(false, args, args.length);
}